> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List a workspace's Spark functions

> List the workspace's functions, each with its signature and live version.

**Required roles**: any role in the workspace



## OpenAPI

````yaml get /api/decisions/{workspace}/functions
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/decisions/{workspace}/functions:
    get:
      tags:
        - Decision functions
      summary: List a workspace's Spark functions
      description: >-
        List the workspace's functions, each with its signature and live
        version.


        **Required roles**: any role in the workspace
      operationId: list_functions_api_decisions__workspace__functions_get
      parameters:
        - name: workspace
          in: path
          required: true
          schema:
            type: string
            maxLength: 64
            pattern: ^[a-z0-9][a-z0-9-]{0,63}$
            description: Workspace slug.
            title: Workspace
          description: Workspace slug.
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/FunctionListResponse'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
        '503':
          description: Service Unavailable
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    FunctionListResponse:
      properties:
        workspace:
          type: string
          title: Workspace
        package:
          type: string
          title: Package
          description: The import name of the workspace's package.
        functions:
          items:
            $ref: '#/components/schemas/FunctionResponse'
          type: array
          title: Functions
      type: object
      required:
        - workspace
        - package
        - functions
      title: FunctionListResponse
    ErrorResponse:
      properties:
        error:
          type: string
          title: Error
          description: A brief description of the error that occurred.
        code:
          type: integer
          title: Code
          description: The HTTP status code associated with the error.
          default: 500
      type: object
      required:
        - error
      title: ErrorResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    FunctionResponse:
      properties:
        workspace:
          type: string
          title: Workspace
        name:
          type: string
          title: Name
        kind:
          type: string
          title: Kind
        summary:
          type: string
          title: Summary
          default: ''
        folder:
          type: string
          title: Folder
          default: ''
        created_by:
          type: string
          title: Created By
        created_at:
          type: string
          format: date-time
          title: Created At
        archived_at:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Archived At
        latest_version:
          anyOf:
            - type: integer
            - type: 'null'
          title: Latest Version
        latest_status:
          anyOf:
            - $ref: '#/components/schemas/DecisionVersionStatusEnum'
            - type: 'null'
        published:
          anyOf:
            - $ref: '#/components/schemas/FunctionPublicationResponse'
            - type: 'null'
        signature:
          anyOf:
            - type: string
            - type: 'null'
          title: Signature
          description: >-
            How the published (or else newest) version is called, e.g.
            rate_for(rate, code, codes).
      type: object
      required:
        - workspace
        - name
        - kind
        - created_by
        - created_at
      title: FunctionResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    DecisionVersionStatusEnum:
      type: string
      enum:
        - draft
        - submitted
        - approved
        - retired
      title: DecisionVersionStatusEnum
      description: |-
        Lifecycle state of a single version.

        ``draft`` → ``submitted`` → ``approved``, with ``reject`` returning a
        submitted version to ``draft`` and ``retire`` taking an approved
        version out of circulation.
    FunctionPublicationResponse:
      properties:
        version:
          type: integer
          title: Version
        published_by:
          type: string
          title: Published By
        published_at:
          type: string
          format: date-time
          title: Published At
      type: object
      required:
        - version
        - published_by
        - published_at
      title: FunctionPublicationResponse
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.